from tkinter import *
import pm_logic as pm

SPEED = 2

root = Tk()
cnv = Canvas(root, width=500, height=500, bg="blue")


# Tekitame tema liigutamise funktsiooni
def move_pacman(pm, dx, dy): cnv.move(pacman_sprite, dx, dy)

# Ja loogilise Pacmani
pacman = pm.PacMan(100, 150, 10, 10, 0, 0, "pacman", callback=move_pacman)

# Tekitame graafilise Pacmani
pacman_sprite = cnv.create_oval(pacman.x - pacman.x_size,
                              pacman.y - pacman.y_size,
                              pacman.x + pacman.x_size,
                              pacman.y + pacman.y_size,
                              fill = "yellow")

ghosts = []

for x, y in [(30, 50), (60, 50), (90, 50)]:
    # Tekitame graafilise Ghosti
    size = 10
    ghost_sprite_i = cnv.create_oval(x - size,
                                     y - size,
                                     x + size,
                                     y +  pacman.y_size,
                                     fill = "cyan")
    # Tekitame tema liigutamise funktsiooni
    def move_ghost(g, dx, dy, ghost_id=ghost_sprite_i):
        cnv.move(ghost_id, dx, dy)

    # Ja loogilise Ghosti
    ghost = pm.Ghost(x, y, 10, 10, 2, 0, "ghost", callback=move_ghost)
    ghosts.append(ghost)


cnv.grid()


# Seome klahvid wasd vastavate callback funktsioonidega, kasutades Tk meetodi bind
def keypress(event):
    movemap = {"w": (0, -SPEED),
               "s": (0, SPEED),
               "a": (-SPEED, 0),
               "d": (SPEED, 0)}
    c = event.char
    dx, dy = movemap[c]
    pacman.set_heading(dx, dy)

def create_world():
    wall_data = [(200, 30, 5, 50),
                 (70, 30, 30, 5),
                 (170, 130, 30, 5),
                 (100, 230, 50, 5),
                 (5, 200, 5, 200),
                 (400, 200, 5, 200),
                 (200, 5, 200, 5),
                 (200, 400, 200, 5)]
    walls = []
    for x, y, x_s, y_s in wall_data:
        cnv.create_rectangle(x-x_s, y-y_s, x+x_s, y+y_s, fill="white")
        walls.append(pm.GameObject(x, y, x_s, y_s, obj_type="wall"))
    return pm.World(walls, [pacman]+ghosts)
                 
wrd = create_world()

def timer_tick(): # Reageerime kella tiksumisele ja registreerib järgmise tiksumise
    wrd.tick()
    root.after(50, timer_tick)
    
root.bind("<KeyPress>", keypress)
timer_tick()
root.mainloop()
